> For the complete documentation index, see [llms.txt](https://docs.aurelia.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.aurelia.io/developer-guides/error-messages/0001-to-0023/aur0015.md).

# AUR0015

yyyy is a native function and, therefore cannot be safely constructed by DI. If this is intentional, please use a callback or cachedCallback resolver.

### **Error message**

`yyyy` is a native function and cannot be safely constructed by DI. If this is intentional, please use a callback or cachedCallback resolver.

### **Parameters**

name (string)

### Error explanation

This error occurs when you attempt to use the DI container to construct a native JavaScript built-in type (such as `String`, `Number`, `Array`, etc.) using `container.invoke(key)` or `container.getFactory(key)`. Native functions cannot be safely constructed by the DI system.

### Common causes

* Attempting to inject or construct a built-in type (like `String`, `Number`, `Array`, etc.) as a dependency.
* Accidentally passing a native function as a key to `container.invoke` or `container.getFactory`.
* Misconfiguration or missing `@inject` decorator for intrinsic types.

### How to fix

* Avoid using native JavaScript types as keys for DI construction.
* If you need to provide a value for a built-in type, use a callback or cachedCallback resolver to supply the value.
* Use the `@inject` decorator to specify the correct dependency key for intrinsic types.

### Debugging tips

* Check the stack trace to see where the native function is being constructed.
* Search your codebase for uses of `container.invoke` or `container.getFactory` with native types.
* Ensure all dependencies are registered with appropriate resolvers.

Please also note that this error could be caused by a plugin and not your application. After ruling out that the error is not being caused by your code, try removing any registered plugins one at a time to see if the error resolves itself.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.aurelia.io/developer-guides/error-messages/0001-to-0023/aur0015.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
